/* ---------------------------------------------------------- 
%   (C)1993,1994,1995 Institute for New Generation Computer Technology 
%       (Read COPYRIGHT for detailed information.) 
%   (C)1996, 1997, 1998, 1999 Japan Information Processing Development Center
%       (Read COPYRIGHT-JIPDEC for detailed information.)
----------------------------------------------------------- */

#ifndef _KLIC_GMODULE_H_
#define _KLIC_GMODULE_H_

struct module_object {
  struct data_object_method_table* method_table;
  q name;
};

#define declare_module_constant(mod,name)	\
{						\
  &module_g_method_table,			\
  name						\
}

struct predicate_object {
  struct data_object_method_table* method_table;
  const struct predicate* pdesc; /* atom tag */
  q module_obj;
  q predicate_name;
};

#define declare_pred_constant(pred,mod,name)	\
{						\
  &predicate_g_method_table,		\
  (struct predicate *)&pred,			\
  makefunctor(&(mod)), \
  name						\
}

#define makepred(x)	makefunctor(&(x))

#endif /* _KLIC_GMODULE_H_ */
