/* ---------------------------------------------------------- 
%   (C)1994,1995 Institute for New Generation Computer Technology 
%       (Read COPYRIGHT for detailed information.) 
%   (C)1996, 1997, 1998, 1999 Japan Information Processing Development Center
%       (Read COPYRIGHT-JIPDEC for detailed information.)
----------------------------------------------------------- */

#ifndef _KLIC_GD_METHTAB_H_
#define _KLIC_GD_METHTAB_H_


/* runtime/generic.c */

extern q GD_STD_GUNIFY(
  struct data_object* g_self, struct data_object* GD_OTHER );

extern q* GD_STD_UNIFY(
  struct data_object* g_self, struct data_object* GD_OTHER );

extern q* GD_STD_GENERIC(
  struct data_object* g_self, long g_method_functor, q* g_argv );
extern q GD_STD_GGENERIC(
  struct data_object* g_self, long g_method_functor, q* g_argv );

extern q GD_STD_COMPARE(
  struct data_object* g_self, struct data_object* GD_OTHER );

extern q GD_STD_HASH(struct data_object* g_self, long level);


extern const struct data_object_method_table G_method_table = {
#ifndef GDUSE_MY_PRINT
  G_STD_PRINT,
#else
  G_rappend(print),
#endif

#ifndef GDUSE_MY_GC
  G_STD_GC,
#else
  G_rappend(gc),
#endif

#ifndef GDUSE_MY_DEALLOCATE
  G_STD_DEALLOCATE,
#else
  G_rappend(deallocate),
#endif

#ifndef GDUSE_MY_ENCODE
  G_STD_ENCODE,
#else
  G_rappend(encode),
#endif

#ifndef GDUSE_MY_GUNIFY
  GD_STD_GUNIFY,
#else
  G_rappend(passive_unify),
#endif

#ifndef GDUSE_MY_UNIFY
  GD_STD_UNIFY,
#else
  G_rappend(active_unify),
#endif

#ifndef GDUSE_MY_GENERIC
  GD_STD_GENERIC,
#else
  G_rappend(generic),
#endif

#ifndef GDUSE_MY_GGENERIC
  GD_STD_GGENERIC,
#else
  G_rappend(guard_generic),
#endif

#ifndef GDUSE_MY_COMPARE
  GD_STD_COMPARE,
#else
  G_rappend(compare),
#endif

#ifndef GDUSE_MY_HASH
  GD_STD_HASH
#else
  G_rappend(hash)
#endif
};

#endif /* _KLIC_GD_METHTAB_H_ */
